
{$APPTYPE GUI}{$MODE DELPHI}

program demo55;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Games;

//const

//type
  
var 
  Twister:TGLTwister;

   
//{$R *.rc}
//{$R *.res}  

 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(3,3, 0,3, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 3,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure ParticleMdl; 
begin 
  Sfera(0,0,0, 0.25,8,8, 1); 
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('Floor04.bmp',0);
  TextureLoadTGAID('water3.tga',0);
  TextureLoadTGAID('CloudsParticles4.tga',1);
  
end;
begin 

  OpenGL_Texture();
  
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-20);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(25,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,-5, 0.1); 

  TextureSelectID(0);
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10);   
  
  Twister.Update(5);
  
  // poligonare con texture
  TextureTGASelectID(0);  
  Twister.DrawPolygon(-5,0,0, 1, 5,32, 64,32);
  
// le costanti usate per impostare la tipologia del'effetto, sono le stesse che sono state usate per la creazione 
// delle nubi, come vine mostrato nel demo 45   
  
  // particelle con set di texture
  TextureTGASelectID(1);                                       
  Twister.DrawParticle(0,0,0, 1, 5,32, 64,10,CLOUD_NORMAL,8,4);
  
  // particelle con uso di elemnti
  TextureTGASelectID(2);// nulla
  Twister.AddParticle(5,0,0, 1, 5,32, 64,14,ParticleMdl);
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Tornado', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
